#
#  controller.py
#  Erwinia
#
#  Created by Alex Rubin on 4/29/09.
#  Copyright (c) 2009 Alex Rubin. All rights reserved.
#

from objc import YES, NO, IBAction, IBOutlet
from Foundation import *
from AppKit import *
from PyObjCTools import AppHelper
import os
from os import path
from BaseHTTPServer import BaseHTTPRequestHandler, HTTPServer
from SocketServer import ThreadingMixIn
import threading
from threading import Thread
import socket
import urllib
import math

fileList = []
chunkSize = 1024
port = 8080

class ErwiniaHandler(BaseHTTPRequestHandler):
	def do_GET(self):
		if self.path == "/":
			self.send_response(200)
			self.send_header("Content-type", "text/html")
			self.end_headers()
			global fileList
			self.wfile.write("<strong>Files:</strong><br />")
			for x in fileList:
				if os.path.getsize(x["filePath"]) < (1024 * 1024):
					self.wfile.write("<a href=\"" + x["fileName"] + "\">" + x["fileName"] + "</a> (Size: " + str(int(os.path.getsize(x["filePath"]) / 1024.0)) + " KB)<br />")
				else:
					self.wfile.write("<a href=\"" + x["fileName"] + "\">" + x["fileName"] + "</a> (Size: " + str(int(os.path.getsize(x["filePath"]) / (1024.0 * 1024.0))) + " MB)<br />")
			return
		else:
			for x in fileList:
				if urllib.unquote(self.path[1:]) == x["fileName"]:
					if not os.path.exists(x["filePath"]):
						self.send_error(404, "File not found")
						return
					self.send_response(200)
					self.send_header("Content-disposition", "attachment; filename=" + x["fileName"])
					self.send_header("Content-length", os.path.getsize(x["filePath"]))
					self.end_headers()
					file = open(x["filePath"], "r")
					global chunkSize
					while True:
						chunk = file.read(chunkSize)
						if chunk == "":
							break
						else:
							self.wfile.write(chunk)
					file.close()
					return
			self.send_error(404, "File not found")
			return

class ThreadedHTTPServer(ThreadingMixIn, HTTPServer):
	pass

class MainServer(Thread):
	def __init__(self):
		Thread.__init__(self)
	def run(self):
		global port
		threadserver = ThreadedHTTPServer(("", port), ErwiniaHandler)
		threadserver.serve_forever()

class controller(NSWindowController):
	
	tableView = IBOutlet()
	arrayController = IBOutlet()
	hostedFiles = []
	
	def awakeFromNib(self):
		server = MainServer()
		server.start()
		
	@IBAction
	def addButton_(self, sender):
		panel = NSOpenPanel.openPanel()
		panel.setCanChooseDirectories_(NO)
		panel.setAllowsMultipleSelection_(NO)
		panel.beginSheetForDirectory_file_modalForWindow_modalDelegate_didEndSelector_contextInfo_(os.getcwd(), None, NSApp().mainWindow(), self, 'openPanelDidEnd:panel:returnCode:contextInfo:', 0)
	
	@AppHelper.endSheetMethod
	def openPanelDidEnd_panel_returnCode_contextInfo_(self, panel, returnCode, contextInfo):
		if returnCode:
			if not os.path.isfile(panel.filenames()[0]):
				alert = NSAlert.alloc().init()
				alert.setMessageText_("Invalid file")
				alert.setInformativeText_("\"" + panel.filenames()[0] + "\" is not a valid file!")
				alert.setAlertStyle_(NSWarningAlertStyle)
				alert.runModal()
				return
			for x in self.hostedFiles:
				if x["fileName"] == os.path.basename(panel.filenames()[0]):
					alert = NSAlert.alloc().init()
					alert.setMessageText_("Duplicate file")
					alert.setInformativeText_("There is already a file with the name \"" + os.path.basename(panel.filenames()[0]) + "\"!")
					alert.setAlertStyle_(NSWarningAlertStyle)
					alert.runModal()
					return
			self.hostedFiles += [NSDictionary.dictionaryWithDictionary_({"fileName": os.path.basename(panel.filenames()[0]), "fileURL": "http://" + socket.gethostbyname(socket.gethostname()) + ":" + str(port) + "/" + os.path.basename(panel.filenames()[0]), "filePath": panel.filenames()[0]})]
			self.arrayController.rearrangeObjects()
			global fileList
			fileList = self.hostedFiles
		else:
			pass
	
	@IBAction
	def removeButton_(self, sender):
		del self.hostedFiles[self.tableView.selectedRow()]
		self.arrayController.rearrangeObjects()
		global fileList
		fileList = self.hostedFiles